﻿<%@ Page Title="Home Page" Language="C#" MasterPageFile="~/Site.master" AutoEventWireup="true"
    CodeBehind="Default.aspx.cs" Inherits="ASPNET._Default" %>

<asp:Content ID="HeaderContent" runat="server" ContentPlaceHolderID="HeadContent">
</asp:Content>
<asp:Content ID="BodyContent" runat="server" ContentPlaceHolderID="MainContent">
    <div id="holder">
    <ul id="html_list">
        <li>Parent 1
            <ul>
            <li>Child 1
                <ul>
                <li>Child of Child 1</li>
                <li>Child of Child 1</li>
                </ul>
            </li>
            <li>Child 2</li>
            <li>Child 3</li>
            </ul>
        </li>
        <li>Parent 2
            <ul>
            <li>Child 1</li>
            <li>Child 2</li>
            <li>Child 3
                <ul>
                <li>Child of Child 3</li>
                <li>Child of Child 3</li>
                <li>Child of Child 3
                    <ul>
                    <li>Yet another child</li>
                    <li>Yet another child</li>
                    <li>Yet another child</li>
                    </ul>
                </li>
                </ul>
            </li>
            </ul>
        </li>
    </ul>
    <div id="empty_div"></div>
    </div>
    <div id="options">
    <input type="radio" id="div_target" name="rendering" />Bind to JSON
    <input type="radio" id="tree_target" name="rendering"/>Bind to HTML Mark-up
    <p>Checkbox mode:</p>
    <input type="radio" value="off" name="checkbox_mode" checked="checked"/>No checkboxes
    <input type="radio" value="biState" name="checkbox_mode"/>Bi state
    <input type="radio" value="triState" name="checkbox_mode"/>Tri state
    <p>Log which events:</p>
    <input type="checkbox" value="igtreeselectionchanged" />Selection Changed
    <input type="checkbox" value="igtreenodeexpanded" />Node Expanded
    <input type="checkbox" value="igtreenodecollapsed" />Node Collapsed
    <input type="checkbox" value="igtreenodecheckstatechanged" />Node Checkstate Changed
    </div>
    <div id="logging">
        <textarea  cols="60" rows="8" id="log_area"></textarea>
    </div>
    <script type="text/javascript">
        $(document).ready(function () {
            var html_list = $("#html_list");
            var html_list_body = html_list.html();
            var empty_div = $("#empty_div");
            var log_area = $("#log_area");
            var current_active = null;

            // Removes any rendered igTrees and also repopulates the initial unordered list
            function destroyTrees() {
                html_list.igTree("destroy");
                empty_div.igTree("destroy");
                html_list.html(html_list_body);
            }

            // JSON array which we'll use as a data source
            var items = [
            {
                "Parent": "Item 1 JSON",
                "Child": [
                    { "Parent": "Sub 1 JSON 1" },
                    { "Parent": "Sub 1 JSON 2" },
                    { "Parent": "Sub 1 JSON 3" }
                    ]
            },
            {
                "Parent": "Item 2 JSON",
                "Child": [
                    { "Parent": "Sub 2 JSON 1" },
                    { "Parent": "Sub 2 JSON 2" },
                    { "Parent": "Sub 2 JSON 3" }
                    ]
            }];

            // handles the initialization of the tree that is built on top of JSON
            $("#div_target").click(function () {
                destroyTrees();
                $("input[type='checkbox']:checked").click();

                empty_div.igTree({
                    dataSourceType: "json",
                    dataSource: items,
                    bindings: {
                        textKey: "Parent",
                        childDataProperty: "Child"
                    },
                    checkboxMode: $("input[name='checkbox_mode']:checked").val()
                });
                current_active = $(empty_div);
            });

            // handles the initialization of the tree that is built on top of HTML mark-up
            $("#tree_target").click(function () {
                destroyTrees();
                $("input[type='checkbox']:checked").click();

                html_list.igTree({
                    checkboxMode: $("input[name='checkbox_mode']:checked").val()
                });
                current_active = $(html_list);
            });
            
            // handles assigning the selected events to the currently active igTree
            $("input[type='checkbox']").click(function () {
                if ($(this).attr("checked")) {
                    switch ($(this).val()) {
                        case "igtreeselectionchanged":
                            $(current_active).bind($(this).val(), function (evt, ui) {
                                $(log_area).append("Selected " +
                                // the condition below takes care of the fact that we have explicit data binding on our JSON tree
                                ((ui.newNodes[0].data.Text == null) ? ui.newNodes[0].data.Parent : ui.newNodes[0].data.Text)
                                 + "\n");
                            }); break;
                        case "igtreenodeexpanded":
                            $(current_active).bind($(this).val(), function (evt, ui) {
                                $(log_area).append("Expanded " +
                                // the condition below takes care of the fact that we have explicit data binding on our JSON tree
                                ((ui.node.data.Text == null) ? ui.node.data.Parent : ui.node.data.Text)
                                 + "\n");
                            }); break;
                        case "igtreenodecollapsed":
                            $(current_active).bind($(this).val(), function (evt, ui) {
                                $(log_area).append("Collapsed " +
                                // the condition below takes care of the fact that we have explicit data binding on our JSON tree
                                ((ui.node.data.Text == null) ? ui.node.data.Parent : ui.node.data.Text)
                                 + "\n");
                            }); break;
                        case "igtreenodecheckstatechanged":
                            $(current_active).bind($(this).val(), function (evt, ui) {
                                $(log_area).append("Interacted with " +
                                // the condition below takes care of the fact that we have explicit data binding on our JSON tree
                                ((ui.node.data.Text == null) ? ui.node.data.Parent : ui.node.data.Text)
                                 + "'s checkbox\n");
                            }); break;
                    }
                }
            });
        });
    </script>
</asp:Content>
